############################################### PAQUETES #############################
library(ClustOfVar)
library(ggplot2)
library(data.table)
library(factoextra)
library(cluster)
library(stats)

############################################### DATOS DE ENTRADA #####################
setwd("e:/XXX/");
Data_atd<-read.csv("91_DataIn.csv", header = TRUE, sep=";",dec = ",");
names(Data_atd)
summary(Data_atd)

############################################### VARIABLES INTERNAS ###################
Data_Dx_b <- data.frame(Data_atd[, c(1,3,4)])  # variables a utilizar
VADTx1<-Data_Dx_b$VADT/(max(Data_Dx_b$VADT)) #por unidad, se utiliz max como base
CxKx1<-Data_Dx_b$CxK/(max(Data_Dx_b$CxK)) #por unidad, se utiliz max como base
Data_Dx <- data.frame(CxKx1,VADTx1)
rownames(Data_Dx)<-Data_atd[,1]

############################################### ALGORITMO DE ASIGNACIN ATD ##########
N_atd<-6
N_iteraciones<-1
data_final <- NULL
cen_final<-NULL

for(i in 1:N_iteraciones)
  {
  k2 <- kmeans(Data_Dx,centers = N_atd,nstart = 500)
  data_1<-data.frame(i,k2$cluster)
  cen_1<-data.frame(i,k2$centers,row.names(k2$centers))
  data_2<-cbind.data.frame(rownames(data_1),data_1)
  data_final <- rbind.data.frame(data_final,data_2)
  cen_final <- rbind.data.frame(cen_final,cen_1)
  print(i)
  }
summary(k2)

colnames(cen_final)<-c("iteracin","CxKx1","VADTx1","cluster")
colnames(data_final)<-c("Distribuidora","iteracin","cluster")

atd_final_iteraciones<-merge(data_final,cen_final)

############################################### GUARDA DATOS EN ARCHIVOS DE SALIDA ####
setwd("e:/XXX/");
write.table(atd_final_iteraciones, "93_ClustersOut.csv", append = FALSE, quote = TRUE, sep = ";",
            eol = "\n", na = "NA", dec = ",", row.names = FALSE,
            col.names = TRUE, qmethod = c("escape", "double"))